#include "libgccvb.h"
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddata.h"  // Actual sounds
#include "pacguymap.h"
#include "pacguychar.h"
#include "dotmap.h"
#include "dotchar.h"
#include "brix.h"
#include "wall1char.h"
#include "wall2char.h"
#include "titlescreenmap.h"
#include "titlescreenchar.h"
#include "level1intromap.h"
#include "level1introchar.h"
#include "level1mapclosed.h"
#include "level1mapopen.h"
#include "enemiesmap.h"
#include "enemieschar.h"
#include "level2intromap.h"
#include "level2introchar.h"
#include "level2mapclosed.h"
#include "level2mapopen.h"




int pacguydir, pacguyx=24, pacguyy=281, pacguyfacingdir, dir, level=0;
int dot1x, dot1y, dot2x, dot2y, dot3x, dot3y, dot4x, dot4y, movingtimer;
int dotx, dotyadd, dotxadd, dotxsubtract, dotysubtract, dottimer, clearmaze=0;
int dot2x, dot2yadd, dot2xadd, dot2xsubtract, dot2ysubtract, iateadot;
int enemyx, enemyy, enemymovetimer, enemydir, wall;
int enemycollxplus, enemycollxminus, enemycollyplus, enemycollyminus;
int ud=1, lr=1, snd=0, sndtimer=0;



HWORD getBGMapChar(bgmap, x, y)
    	{ 
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7FF);  
    	} 



void level_change()
{	

	level++;	// change back to level++; when done testing level music.

		StopAllSounds();	

	if (level==1) copymem((void*)CharSeg1, (void*)LEVEL1INTROCHAR, 256*16);
	if (level==1) copymem((void*)BGMap(1), (void*)LEVEL1INTROMAP, 256*16);	
	if (level==2) copymem((void*)CharSeg1, (void*)LEVEL2INTROCHAR, 256*16);
	if (level==2) copymem((void*)BGMap(1), (void*)LEVEL2INTROMAP, 256*16);
	if (level==3) level=0, main_3();

	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	
	


	
	while(!(vbReadPad()&K_A)){}
	while(vbReadPad()&K_A){}	

	switch (level) {
	
	case 1:

	PlaySound(level1musictreble);
	PlaySound(level1musicbass);
	break;
	
	case 2:
	PlaySound(level2musictreble);
	PlaySound(level2musicbass);
	break;

	}

	if (level==1) enemyx=340, enemyy=100, enemymovetimer=0;
	pacguyx=24, pacguyy=24;
	if (level==1) enemyx=400, enemyy=200, dot1x=160, dot1y=165, dot2x=40, dot2y=180;
	if (level==2) enemydir=1, enemyx=172, enemyy=20, dot1x=200, dot1y=180, dot2x=200, dot2y=200;	
	
	
	if (level==1) {
	copymem((void*)BGMap(1), (void*)LEVEL1MAPCLOSED, 256*16);	
	copymem((void*)CharSeg1, (void*)WALL1CHAR, 256*16);	
	}
	
	if (level==2) {
	copymem((void*)BGMap(1), (void*)LEVEL2MAPCLOSED, 256*16);	
	copymem((void*)CharSeg1, (void*)WALL2CHAR, 256*16);
	}

	clearmaze=0;

	copymem((void*)CharSeg0, (void*)DOTCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)DOTMAP, 256*16);

	copymem((void*)CharSeg2, (void*)PACGUYCHAR, 256*16);
	copymem((void*)BGMap(2), (void*)PACGUYMAP, 256*16);	

	copymem((void*)CharSeg3, (void*)ENEMIESCHAR, 256*16);
	copymem((void*)BGMap(3), (void*)ENEMIESMAP, 256*16);	

	main_2();

}

int main()
{
	InitSound();
	main_3();
}

int main_3()
{
	vbDisplayOn();
	vbDisplayShow();	



	while(!(vbReadPad()&K_A))
	{
	DoSounds();

	PlaySound(tstreble);
	PlaySound(tsbass);

	
	copymem((void*)CharSeg1, (void*)TITLESCREENCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)TITLESCREENMAP, 256*16);
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);

	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	


	
	

	
	
	
	
	}
	level_change();
	}
	
	
int main_2 ()
	{
	


	
	//StopAllSounds();
	

				
	
	
	while(1)
	{
	


	
	DoSounds();
	if ((pacguyx>dotxadd) && (pacguyx<dotxsubtract) && (pacguyy>dotyadd) && (pacguyy<dotysubtract)) dot1x=400;
	if ((pacguyx>dot2xadd) && (pacguyx<dot2xsubtract) && (pacguyy>dot2yadd) && (pacguyy<dot2ysubtract)) dot2x=400;
	
	
	if (dot1x==400) dot1x=401, PlaySound(eatdot);
	//if (dot2x==400) 
	
	if (dot2x==400) dot2x=401, PlaySound(eatdot);
	
	



	if (level==2) 
	{
	enemymovetimer++;

		
	enemycollxplus=enemyx+16, enemycollxminus=enemyx-16, enemycollyplus=enemyy+16, enemycollyminus=enemyy-16;
	if ((pacguyx>enemycollxminus) && (pacguyx<enemycollxplus) && (pacguyy>enemycollyminus) && (pacguyy<enemycollyplus)) level--, level_change();
	
	if ((enemyx==346) && (enemydir==1)) enemydir=4;
	if ((enemyy==140) && (enemydir==4)) enemydir=2;
	if ((enemyx==162) && (enemydir==2)) enemydir=3;
	if ((enemyy==20) && (enemydir==3)) enemydir=1;
	
	//if (enemydir>4) enemydir=1;
	

	if ((enemymovetimer>1) && (enemydir==1)) enemymovetimer=0, enemyx++;
	if ((enemymovetimer>1) && (enemydir==2)) enemymovetimer=0, enemyx--;	
	if ((enemymovetimer>1) && (enemydir==3)) enemymovetimer=0, enemyy--;
	if ((enemymovetimer>1) && (enemydir==4)) enemymovetimer=0, enemyy++;	
	}



	if((vbReadPad()&K_LL) && (vbReadPad()&K_LU)) lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LL) && (vbReadPad()&K_LD)) lr=0, ud=0, movingtimer=0;	
	if((vbReadPad()&K_LR) && (vbReadPad()&K_LU)) lr=0, ud=0, movingtimer=0;	
 	if((vbReadPad()&K_LR) && (vbReadPad()&K_LD)) lr=0, ud=0, movingtimer=0;		

	if((!(vbReadPad()&K_LR)) && (!(vbReadPad()&K_LL))) lr=1, movingtimer=0;
	if((!(vbReadPad()&K_LU)) && (!(vbReadPad()&K_LD))) ud=1, movingtimer=0;

	
	vbSetWorld(28, WRLD_ON|2, pacguyx, 0, pacguyy, pacguyfacingdir, 0, 0, 15, 40);	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);	
	vbSetWorld(30, WRLD_ON, dot1x, 0, dot1y, dotx, 0, 0, 7, 8);	
	vbSetWorld(29, WRLD_ON, dot2x, 0, dot2y, dotx, 0, 0, 7, 8);	
	vbSetWorld(27, WRLD_ON|3, enemyx, 0, enemyy, 0, 0, 0, 16, 16);	
	
	// collision detection on walls



	
		

	if((vbReadPad()&K_LL) && (lr==1)) movingtimer++;	
	if((vbReadPad()&K_LL) && (lr==1) && (!(getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) && (movingtimer>0)) movingtimer=0, pacguyx--, dotxadd=-10, pacguyfacingdir=0;
	if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) pacguyx=pacguyx+2, lr=0, movingtimer=0;	
	if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+1)==512)) pacguyx=pacguyx+2, lr=0, movingtimer=0;		
	if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) pacguyx=pacguyx+2, lr=0, movingtimer=0;		
	//if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) lr=0, movingtimer=0;	
	//if((vbReadPad()&K_LL) && (pacguyfacingdir>0)) enemymovetimer=0;
	
	if((vbReadPad()&K_LR) && (lr==1)) movingtimer++;
	if((vbReadPad()&K_LR) && (lr==1) && (!(getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) && (movingtimer>0)) movingtimer=0, pacguyx++, dotxadd=0, pacguyfacingdir=32;
	if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) pacguyx=pacguyx-2, lr=0, movingtimer=0;	
	if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+1)==512)) pacguyx=pacguyx-2, lr=0, movingtimer=0;		
	if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) pacguyx=pacguyx-2, lr=0, movingtimer=0;		
	//if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) lr=0, movingtimer=0;	
	//if((vbReadPad()&K_LR) && (pacguyfacingdir<36) && (pacguyfacingdir>36)) enemymovetimer=0;
	
	if((vbReadPad()&K_LU) && (ud==1)) movingtimer++;
	if((vbReadPad()&K_LU) && (ud==1) && (!(getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) && (movingtimer>0)) movingtimer=0, pacguyy--, dotyadd=-10, pacguyfacingdir=16;	
	if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) pacguyy=pacguyy+2, ud=0, movingtimer=0;
	if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+1, (pacguyy/8)+0)==512)) pacguyy=pacguyy+2, ud=0, movingtimer=0;	
	if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) pacguyy=pacguyy+2, ud=0, movingtimer=0;	
	//if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) ud=0, movingtimer=0;	
	//if((vbReadPad()&K_LU) && (pacguyfacingdir<16) && (pacguyfacingdir>16)) enemymovetimer=0;	
	
	if((vbReadPad()&K_LD) && (ud==1)) movingtimer++;
	if((vbReadPad()&K_LD) && (ud==1) && (!(getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) && (movingtimer>0)) movingtimer=0, pacguyy++, dotyadd=-10, pacguyfacingdir=48;		
	//if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) pacguyy=pacguyy-2, ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+1, (pacguyy/8)+2)==512)) pacguyy=pacguyy-2, ud=0, movingtimer=0;	
	if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) pacguyy=pacguyy-2, ud=0, movingtimer=0;	
	//if((vbReadPad()&K_LD) && (pacguyfacingdir>48)) enemymovetimer=0;
	
	

	dottimer++;
	if (dottimer>14) dottimer=0, dotx=dotx+8;
	if (dotx>24) dotx=0;

	
	// collision detection on dots
	
	dotxadd=dot1x-16, dotxsubtract=dot1x+8, dotyadd=dot1y-16, dotysubtract=dot1y+8;
	dot2xadd=dot2x-16, dot2xsubtract=dot2x+8, dot2yadd=dot2y-16, dot2ysubtract=dot2y+8;	
	
	


	if ((dot1x==401) && (clearmaze==0) && (dot2x==401)) clearmaze=1;
	
	

	
	
	if (pacguyy>200) level_change();
	
	

	
	
	if ((dot1x==401) && (clearmaze==0) && (dot2x==401)) clearmaze=1;
	


	
	if (clearmaze==1) {
		if (level==1) copymem((void*)BGMap(1), (void*)LEVEL1MAPOPEN, 256*16);
		if (level==2) copymem((void*)BGMap(1), (void*)LEVEL2MAPOPEN, 256*16);	
		clearmaze=2;
		}
	
	
	}
	}
	//StopAllSounds();
	//main_3();
	//}
	